#define SJ_PRIV_HASH 10
#define SJ_MEMORY_HASH 10
#define MAX_KEY_ELEMENTS 6
#define MAX_RESTRICTIONS_ELEMENTS 5
#define MAX_RESTRICTIONS 256
#define BUFFSIZE 256
#define NO_PRIV  { {"NONE",""}, { "" } }
#define ALL_PRIV { {"ALL",""}, { "" }  }
#define NULL_ARGV { "","","","","","","" };

struct sj_priv {
    int             pid;
    struct sj_restriction *restriction;
    struct sj_priv *next;
    struct sj_priv *prev;
};

struct sj_argv_memory {
    int             pid;
    char            argv[MAX_KEY_ELEMENTS + 1][BUFFSIZE];
    struct sj_argv_memory *next;
};


struct sj_restriction {
    int             r_index;
    char           *key[MAX_KEY_ELEMENTS];
    char           *restrictions[MAX_RESTRICTIONS][MAX_RESTRICTIONS_ELEMENTS];	/*
										 * Array 
										 * of 
										 * argv 
										 * restrictions, 
										 * one 
										 * array 
										 * per 
										 * argumetnt 
										 */
};

typedef struct sj_restriction SJ_RESTRICTION;
typedef struct sj_priv SJ_PRIV;
typedef struct sj_argv_memory SJ_MEMORY;

SJ_PRIV        *sj_priv_hash[SJ_PRIV_HASH];
SJ_MEMORY      *sj_argv_memory_hash[SJ_MEMORY_HASH];

SJ_RESTRICTION  sj_restrictions[] = {
    {0, {NULL}, {{"NONE", NULL}, {NULL}}},
    {1, {NULL}, {{"ALL", NULL}, {NULL}}},
    {2, {"/bin/su", NULL}, {{"ALL", NULL}, {NULL}}}, 
    {3, {"/usr/bin/sudo", NULL}, {{"ALL", NULL}, {NULL}}}, 
    {4, {NULL}, {NULL}}
    
};



/* 

     {6, {"/test1", NULL}, {{"/bin/sh", "-c", "/test1", NULL}, {"/bin/sh", "-c", "/test2", NULL}, {"/bin/sh", "-c", "/test3", NULL}, {"/test1", NULL}, {"/test2",
							    NULL},
      {"/test3", NULL}, {NULL}}},
    {7, {"/bin/sh", "-c", "/test2", NULL},
     {{"/bin/sh", "-c", "/test1", NULL}, {"/bin/sh", "-c", "/test2", NULL},
      {"/test2", NULL}, {NULL}}},
    {8, {"/bin/sh", "-c", "/test3", NULL},
     {{"/bin/sh", "-c", "/test2", NULL}, {"/bin/sh", "-c", "/test3", NULL},
      {"/test3", NULL}, {NULL}}},
    {9, {"/bin/sh", "/test3", NULL}, {{"/test3", NULL}, {NULL}}},
    {10, {"/bin/sh", "/test2", NULL}, {{"/test3", NULL}, {NULL}}},

*/
